Attribute VB_Name = "DAY"
Sub DailyOut()

Print #3, f7(DOY); f7(Tmax); f7(Tmin); f7(VPD); f7(PAR);
Print #3, f7(CanopyGrossPsn); f7(GCE); f7(GCEStat); f7(CanopyNetPsn); f7(FolMass)

TotGCEPred = TotGCEPred + CanopyGrossPsn        ' totals for different
TotGCEMeas = TotGCEMeas + GCE                   ' calcs of gross carbon
TotGCEStat = TotGCEStat + GCEStat               ' exchange (g/m2.day)
TotNetPsnPred = TotNetPsnPred + CanopyNetPsn

If DayOut.Check1(0) = 1 Then outdaty(1, iday) = CanopyGrossPsn
If DayOut.Check1(1) = 1 Then outdaty(2, iday) = GCE
If DayOut.Check1(2) = 1 Then outdaty(3, iday) = GCEStat
If DayOut.Check1(3) = 1 Then outdaty(4, iday) = ETrans
If DayOut.Check1(4) = 1 Then outdaty(5, iday) = FolMass
If DayOut.Check1(5) = 1 Then outdaty(6, iday) = Tmin
If DayOut.Check1(6) = 1 Then outdaty(7, iday) = Tmax
If DayOut.Check1(7) = 1 Then outdaty(8, iday) = PAR

outdatx(iday) = DOY + nyears * 365

End Sub

Sub DayFinalOut()

If Val(S.maxdays) > 0 Then
  countdays = ZMin(Val(S.maxdays), ndays)
Else
  countdays = ndays
End If
MeanGCEPred = TotGCEPred / countdays                ' average values for gross
MeanGCEMeas = TotGCEMeas / countdays                ' carbon exchange over the
MeanGCEStat = TotGCEStat / countdays                ' data set (g/m2.day)
MeanNetPsnPred = TotNetPsnPred / countdays

Print #3,
Print #3, " -------- Mean GCE ------ Mean Net Psn         "
Print #3, "    PnET   Tower    Stat   PnET"
Print #3,
Print #3, f8(MeanGCEPred); f8(MeanGCEMeas); f8(MeanGCEStat); f8(MeanNetPsnPred);
Print #3, "   gC/m2.day"
Print #3,
Print #3, f8(MeanGCEPred * 365); f8(MeanGCEMeas * 365); f8(MeanGCEStat * 365); f8(MeanNetPsnPred * 365);
Print #3, "   gC/m2.yr"

Close #3

VarName$(1) = "PnET": VarName$(2) = "Tower"
VarName$(3) = "Stat": VarName$(4) = "Trans"
VarName$(5) = "Fol M": VarName$(6) = "TMin"
VarName$(7) = "TMax": VarName$(8) = "PAR"

For j = 1 To countdays
  If outdatx(j) > XMax Then XMax = outdatx(j)
  If outdatx(j) < XMin Then XMin = outdatx(j)
  For i = 1 To 8
    If outdaty(i, j) > YMax(i) Then YMax(i) = outdaty(i, j)
    If outdaty(i, j) < YMin(i) Then YMin(i) = outdaty(i, j)
  Next i
Next j

For i = 1 To 3: YMax(i) = Int(YMax(i) + 1): Next i
Call Max3(YMax(1), YMax(2), YMax(3))
If DayOut.Check1(0) = 0 Then YMax(1) = 0
If DayOut.Check1(1) = 0 Then YMax(2) = 0
If DayOut.Check1(2) = 0 Then YMax(3) = 0

YMin(0) = 0
For i = 1 To 8
 If YMax(i) <> 0 Or YMin(i) <> 0 Then
  If Abs(YMin(i)) > YMax(i) Then YMax(i) = Abs(YMin(i))
  If Abs(YMin(i)) / YMax(i) > YMin(0) Then YMin(0) = Abs(YMin(i)) / YMax(i)
 End If
Next i
YMin(0) = YMin(0) * 100

Call plot("Day", XMax, XMin, 8, VarName$(), YMax(), YMin(), countdays, outdatx(), outdaty())
 
outpt2.Visible = True
outpt2.Cls
outpt2.Print " -------- Mean GCE ------ Mean Net Psn"
outpt2.Print "    PnET   Tower    Stat   PnET"
outpt2.Print f8(MeanGCEPred); f8(MeanGCEMeas); f8(MeanGCEStat); f8(MeanNetPsnPred);
outpt2.Print "   gC/m2.day"
outpt2.Print f8(MeanGCEPred * 365); f8(MeanGCEMeas * 365); f8(MeanGCEStat * 365); f8(MeanNetPsnPred * 365);
outpt2.Print "   gC/m2.yr"


End Sub

Sub DayInit()
  
  FolMass = Val(FolMassMin)
  TotGCEPred = 0: TotGCEMeas = 0: TotGCEStat = 0: TotNetPsnPred = 0
  GDDTot = 0: OldGDDFolEff = 0: GDDFolEff = 0

                              ' initialize output file
  Open PnET.OutDir + ".out" For Output As #3
  f82 = "@@@@@@@ "
  Print #3, " FolNCon  SLWMAx   SLWdel  AmaxA   AmaxB  AmxFrc HalfSat      k BFolRFrac "
  Print #3, Format(FolNCon, f82); Format(SLWmax, f82); Format(SLWdel, f82); Format(AmaxA, f82);
  Print #3, Format(AmaxB, f82); Format(AmaxFrac, f82); Format(HalfSat, f82); Format(k, f82); Format(BaseFolRespFrac, f82)
  
  Print #3,: Print #3, "    day    Tmax    Tmin     VPD    PAR      GCE  GCEmeas GCEStat Net Psn FolMass"
  
'  BudC is calculated in AllocateYr for Pnet-II and Pnet-CN
  BudC = (FolMassMax - FolMass) * CFracBiomass
  
  For j = i To ndays          ' initialize output arrays and max and min values
    outdatx(j) = 0
    For i = 1 To 8
      outdaty(i, j) = 0
     Next i
  Next j

  For i = 1 To 8
    YMax(i) = 0: YMin(i) = 0
  Next i
  XMax = 0: XMin = 0


End Sub
Sub PnETDay()
  outpt3.Visible = True
  nyears = 0
  Call DayInit
  For iday = 1 To ndays
   Call ReadDay
     If NewYear = 1 Then
       nyears = nyears + 1
       GDDTot = 0: OldGDDFolEff = 0: GDDFolEff = 0
     End If
     GCE = valid1: GCEStat = valid2
   Call Scenario
   Call AtmEnviron
   Call Phenology(1)
     DWater = 1                               ' assuming no water stress
   Call Photosyn
   Call Phenology(2)
   Call DailyOut
   If iday = Val(S.maxdays) And Val(S.maxdays) > 0 Then iday = ndays
  Next iday
  outpt3.Visible = False
  Call DayFinalOut
  Close #1: Close #2: Close #3: Close #4: Close #5
End Sub
 
