Attribute VB_Name = "II"

Sub PnetIIGIS()
  Dim npixls As Integer, nrow As Integer, ncol As Integer
  Dim nyrs As Integer, VegTypeCell As Integer, yrr As Integer
  Dim WHCGIS, dom(13) As Integer, pixid As Integer, kveg As Integer
  Dim climtype As String * 5, Pixelid As String * 13, tempname As String * 13
  ' Initialize pixel id to 0 -i.e. not present in the climate file
  ' kveg is counter for ntypes if do all possible vegetations
  
  pixid = 0
  Pixelid = " "
  rdFolN = 0
  Close #11: Close #12
  Open PnET.InDir + PnET.GridFile + ".clm" For Input As #11
  Input #11, npixls, nrow, ncol, nyrs, climtype$

  Open PnET.OutDir + "GISOut.log" For Output As #12
  outputline$ = "  Input climate file: " + PnET.InDir + PnET.GridFile + ".clm" _
      + "  Scenario file: " + Trim(sitefile(stype)) + ".sit"
  Print #12, outputline$
  today$ = Date$
  ozstring$ = " No ozone,"
  If SC.UseO3 = 1 Then
    ozstring$ = " ozone included, "
  End If
  outputline$ = today$ + " Pnet-II run for " + PnET.NYrsCell + " years" _
       + ozstring$
  Print #12, outputline$
  
  Print #12, "Identifier       LAT    LON    ELEV   WHC   VegT   Prec  O3  "; _
      "     ET  Drain  "; "  Psn"; " NPPFol"; "  NPPWd"; "  NPPRt"; "    NEP "; "   GDD  "
  outpt3.Visible = True
  
 If Left$(climtype$, 1) = "C" Or Left$(climtype$, 1) = "c" Then
   Call ClimCalcIn
 End If
 
 If Right$(climtype$, 1) = "I" Or Right$(climtype$, 1) = "i" Then
    pixid = 1
 End If
 
 For i = 1 To Val(PnET.NumGridCells)
'   re-initialize some items for next pixel
    Call SiteInit
    outpt.Cls:  outpt3.Print "cell #": outpt3.Print i
    
    kveg = 1
    If (pixid = 1) Then
         Input #11, Lat_in, Lon, Elev, VegTypeCell, WHCGIS, Pixelid
    Else
        Input #11, Lat_in, Lon, Elev, VegTypeCell, WHCGIS
    End If

' Loop through all possible veg types
VegLoop:    If (VegTypeCell = 100) Then
        If kveg <= ntypes Then
            VegTypeCell = kveg
            kveg = kveg + 1
        End If
    End If

        If (VegTypeCell <> -9999) Then

'   process pixel only if vegetation shows presence of real data
   
           PnET.VegComb = typlst(Val(VegTypeCell))
           Call PnET.VegComb_Change
        End If
' Reset Lat from SIT file to the climate file's Lat and WHC
    Lat = Lat_in
    WHC = WHCGIS
        
    If (kveg > 2) Then GoTo skipread
    
    If Left$(climtype$, 1) = "R" Or Left$(climtype$, 1) = "r" Then
     For j = 1 To 12
       Input #11, yrr, dom(j), TMaxGIS(j), TMinGIS(j), PARGIS(j), _
          PrecGIS(j), NH4GIS(j), NO3GIS(j), O3GIS(j), CO2GIS(j)
     Next j
    Else
     Call ClimCalc(Lat, Lon, Elev)
    End If
skipread:
    If VegTypeCell <> -9999 Then
     nyears = 0
     Call IIInit
     dom(13) = 380
     '   Added to accommodate potential use with ozone additions
     '   Note that O3Effect(layer) is set to zero in IINewYear
     '   UseO3 = 1
     WUEO3Eff = 0
     
     For iyr = 1 To PnET.NYrsCell
     For imo = 1 To 12
   
          DaySpan = daysinmo(imo)
    
         iday = (iyr - 1) * 12 + imo
       'DOY = imo * 30 - 15
         DOY = dom(imo)
       'DaySpan = 30
     '    If imo = 2 Then DaySpan = 28
     '    DaySpan = dom(imo + 1) - dom(imo)
       Tmaxin = TMaxGIS(imo): Tminin = TMinGIS(imo): PARin = PARGIS(imo): Precin = PrecGIS(imo)
       NH4in = NH4GIS(imo): NO3in = NO3GIS(imo): O3 = O3GIS(imo) / 1000: co2in = CO2GIS(imo)
       
       If imo = 1 And iday <> 1 Then
         Call AllocateYr
         Call IIYearOut
       End If
       If imo = 1 Or iday = 1 Then Call IINewYear
       Call Scenario
       Call AtmEnviron
       Call Phenology(1)
       Call Photosyn
       Call Waterbal
       Call SoilResp
       Call AllocateMo
       Call Phenology(2)
       Call IIDOYOut
     Next imo
   Next iyr
  Else
    TotPrec = -999.9
    totTrans = -990.9
    TotEvap = -9
    TotDrain = -999.9
    TotPsn = -999.9
    NPPFolYr = -999.9
    NPPWoodYr = -999.9
    NPPRootYr = -999.9
  End If
  'End of test for undefined pixels (more than 50% water)

endit:
  
  Print #12, Pixelid, f6(Lat); f6(Lon); f6(Elev); f6(WHC); f6(VegTypeCell); _
       f6(TotPrec); f6(TotO3Dose); f6(totTrans + TotEvap) + f6(TotDrain); _
       f6(Int(TotPsn)); f6(Int(NPPFolYr)); f6(Int(NPPWoodYr)); _
       f6(Int(NPPRootYr)); f6(Int(NEP)); f5(GDDTot)
 
  
 Call IIFinalOut
 outpt.Visible = False: outpt3.Visible = False

'loop for next veg type if VegTypeCell originally was 100
If (kveg > 1 And kveg <= ntypes) Then
    VegTypeCell = 100
    GoTo VegLoop
End If
Next i
Close #11: Close #12
End Sub
Sub IIDOYOut()
  
'*********************** Print monthly variables *************************
  
kludge$ = ""
out$ = kludge$ + f4(DOY) + f5(Tmin) + f5(Tmax) + f5(PAR) + f5(Prec) + f5(LAI) _
      + f6(GrsPsnMo) + f6(NetPsnMo) + f6(SoilRespMo) + f6(NetCBal) _
      + f6(Water) + f6(Drainage) + f6((Trans + Evap)) + f6(SnowPack) _
      + f6((DWater * DVPD))
If PrintLevel = 1 And nyears Mod PrintInt = 0 And IIout1.Option3 = True Then
  outpt.Print out$
End If

If RealYear >= Val(IIout1.TabOutFrom) And RealYear <= Val(IIout1.TabOutTo) Then
  Print #3, out$
End If

If IIout1.Option1 = True And RealYear >= Val(IIout2.GraphFrom) And RealYear <= Val(IIout2.GraphTo) Then
  outn = outn + 1
  outdatx(outn) = (nyears - 1) * 365 + DOY
  If IIout2.Check1(0) = 1 Then outdaty(1, outn) = NetCBal
  If IIout2.Check1(1) = 1 Then outdaty(2, outn) = Drainage
  If IIout2.Check1(2) = 1 Then outdaty(3, outn) = FolMass
  If IIout2.Check1(3) = 1 Then outdaty(4, outn) = valid1
  If IIout2.Check1(4) = 1 Then outdaty(5, outn) = valid2
  If IIout2.Check1(5) = 1 Then outdaty(6, outn) = valid3
  If IIout2.Check1(6) = 1 Then outdaty(7, outn) = Prec
  If IIout2.Check1(7) = 1 Then outdaty(8, outn) = Tave
                   
End If
 If Left(PnET.ProjType, 1) = "S" Or Left(PnET.ProjType, 1) = "s" Then
  Print #5, f8(RealYear); f8(DOY); f8(GrsPsnMo); f8(NetPsnMo); _
          f8(NetCBal); f8(Trans + Evap); f8(Drainage); f8(FolMass); _
          f8(Prec); f8(O3); f8(Tave)
End If
  
End Sub

Sub IIFinalOut()

If IIout1.Option1 = True Then
 VarName$(1) = "CBAL": VarName$(2) = "Drain"
 VarName$(3) = "FolMas": VarName$(4) = "V1"
 VarName$(5) = "V2": VarName$(6) = "V3"
 VarName$(7) = "Prec": VarName$(8) = "Tave"
  
XMax = outdatx(1): XMin = outdatx(1)
 For j = 1 To outn
   If outdatx(j) > XMax Then XMax = outdatx(j)
   If outdatx(j) < XMin Then XMin = outdatx(j)
   For i = 1 To 8
     If outdaty(i, j) > YMax(i) Then YMax(i) = outdaty(i, j)
     If outdaty(i, j) < YMin(i) Then YMin(i) = outdaty(i, j)
   Next i
 Next j
    
 YMin(0) = 0
 For i = 1 To 8
  If YMax(i) <> 0 Or YMin(i) <> 0 Then
   If Abs(YMin(i)) > YMax(i) Then YMax(i) = Abs(YMin(i))
   If Abs(YMin(i)) / YMax(i) > YMin(0) Then YMin(0) = Abs(YMin(i)) / YMax(i)
  End If
 Next i
 YMin(0) = YMin(0) * 100

 Call plot("Day", XMax, XMin, 8, VarName$(), YMax(), YMin(), outn, outdatx(), outdaty())
End If
  
If IIout1.Option2 = True Then
 VarName$(1) = "NPPF": VarName$(2) = "NPPW"
 VarName$(3) = "Drain": VarName$(4) = "NEP"
 VarName$(5) = "V1": VarName$(6) = "V2"
 VarName$(7) = "V3": VarName$(8) = "V4"
 
 XMax = outdatx(1): XMin = outdatx(1)
 For j = 1 To outn
   If outdatx(j) > XMax Then XMax = outdatx(j)
   If outdatx(j) < XMin Then XMin = outdatx(j)
   For i = 1 To 8
     If outdaty(i, j) > YMax(i) Then YMax(i) = outdaty(i, j)
     If outdaty(i, j) < YMin(i) Then YMin(i) = outdaty(i, j)
   Next i
 Next j
  
 YMin(0) = 0
 For i = 1 To 8
  If YMax(i) <> 0 Or YMin(i) <> 0 Then
   If Abs(YMin(i)) > YMax(i) Then YMax(i) = Abs(YMin(i))
   If Abs(YMin(i)) / YMax(i) > YMin(0) Then YMin(0) = Abs(YMin(i)) / YMax(i)
  End If
 Next i
 YMin(0) = YMin(0) * 100
 Call plot("Day", XMax, XMin, 8, VarName$(), YMax(), YMin(), outn, outdatx(), outdaty())
End If

If IIout1.Option2 = True Or IIout1.Option1 = True Then
  dummy = InputBox("Hit 'OK' to continue", "Output - Hold", , 6000, 7500)
  outpt.Visible = False
End If

End Sub

Sub IIInit()
  RealYear = Val(S.RunModelFrom)
  If Left(PnET.ProjType, 1) = "S" Or Left(PnET.ProjType, 1) = "s" Then
'*************** initialize output file ********************************
   Close #3: Close #4: Close #5

   Open PnET.OutDir + ".oal" For Output As #3
   Print #3, "Input Files   ", TypeName$, SiteName$
   outputline$ = "Climate file: " + opClimFile$ + " Scenario :" _
       + OpSiteFile$
   Print #3, outputline$
   today$ = Date$
   nyrs$ = S.RunModelTo - S.RunModelFrom
' Label output with checkboxes for O3 and CO2
   ozstring$ = " No ozone,"
   co2string$ = " Fixed CO2 " + SC.FixedCO2
   If SC.UseO3 = 1 Then
    ozstring$ = " ozone included, "
   End If
   If SC.CCRamp = 1 Then
    co2string$ = " Using Mauna Loa CO2 ramp "
   End If
   outputline$ = today$ + " Username Pnet-II run for " + nyrs$ + " years" _
       + ozstring$ + co2string$
   Print #3, outputline$
 
   Open PnET.OutDir + ".ody" For Output As #5
   Print #5, "Input Files   ", TypeName$, SiteName$
    outputline$ = "Climate file: " + opClimFile$ _
        + " Scenario : " + OpSiteFile$
   Print #5, outputline$
' Label output with checkboxes for O3 and CO2
   outputline$ = today$ + " Username Pnet-II run for" + nyrs + " years" _
       + ozstring$ + co2string$
   Print #5, outputline$

   Print #5, "    YEAR      DOY   grspsn   netpsn NetCBal     ET       Drain  FolMass    Prec     O3     Tave"


   Open PnET.OutDir + ".oyr" For Output As #4
   If (Val(S.maxdays) > 0) Then
     maxyears = S.maxdays / 12
   Else
     maxyears = S.RunModelTo - S.RunModelFrom + 1
   End If
   Print #4, "Input Files   ", TypeName$, SiteName$
   outputline$ = "Climate file: " + opClimFile$ _
         + " Scenario : " + OpSiteFile$
   Print #4, outputline$
  
   outputline$ = today$ + " Username  Pnet-II run for " + Str$(maxyears) + " years" _
       + ozstring$ + co2string$
   Print #4, outputline$
 ' Update in Rev 5.0-1.4vb to format of .oyr file column headers
   Print #4, " YEAR GrossPsn NetPsn NPPFol NPPWood NPPRoot Ppt(cm) O3(ppb)   ET  Drain   NEP"

'*************************** initialize *******************************
 End If
 If IIout1.Option3 = True Or IIout1.Option4 = True Then
   outpt.Visible = True
   PrintLevel = 1             ' no graphical output - print tables to outpt form
 Else
   PrintLevel = 0             ' graphical output - do not print tables to outpt form
 End If

  For j = i To ndays          ' initialize output arrays and max and min values
    outdatx(j) = 0
    For i = 1 To 8
      outdaty(i, j) = 0
    Next i
  Next j

  For i = 1 To 8
    YMax(i) = 0: YMin(i) = 0
  Next i
  XMax = 0: XMin = 0

  GDDTot = 0
  outn = 0
          
End Sub


Sub IINewYear()
Dim leapyr As Integer
If nyears > 0 Then RealYear = RealYear + 1
leapyr = Int(RealYear / 4) * 4 - RealYear
If (leapyr = 0) Then daysinmo(2) = 29

HarvYet = 0: NetNMinLastYr = NetNMinYr

If Left(PnET.ProjType, 1) = "S" Or Left(PnET.ProjType, 1) = "s" Then
 If RealYear <= Val(S.RealClimFrom) Or RealYear > Val(S.RealClimTo) Then
  Close #2
  Open opClimFile$ For Input As #2
  Line Input #2, temp$
  Line Input #2, temp$
  Line Input #2, temp$
  Input #2, yr, yod
 End If
End If

nyears = nyears + 1
'ThisYear = BaseYear + nyears

'************** Initialize annual and total variables ********************

GDDTot = 0: WoodMRespYr = 0: SoilRespYr = 0
totTrans = 0: TotPsn = 0: TotGrossPsn = 0: TotDrain = 0: TotPrec = 0: TotEvap = 0
FolProdCYr = 0: WoodProdCYr = 0: RootProdCYr = 0
FolMRespYr = 0: WoodMRespYr = 0: RootMRespYr = 0
FolGRespYr = 0: WoodGRespYr = 0: RootGRespYr = 0
TotAnnFolMass = 0: ixFolMass = 0
GDDFolEff = 0: GDDWoodEff = 0: OldGDDFolEff = 0: OldGDDWoodEff = 0:
PosCBalMassTot = 0: PosCBalMassIx = 0
Dwatertot = 0: DwaterIx = 0
LightEffMin = 1
'   Add for Ozone initialization
TotO3Dose = 0

For nlayer = 1 To 50
O3Effect(nlayer) = 0
Next nlayer


outpt.Cls

If IIout1.Option3 = True Or IIout1.Option4 = True Then
 If PrintLevel = 1 And nyears Mod PrintInt = 0 Then
   outpt.Print Title$
   outpt.Print "YEAR: ";
   outpt.Print f7(RealYear);
   outpt.Print "", "", "", "", FolNCon; "%N"
   outpt.Print " ************************************************************************************************"
   outpt.Print "      min T max T   PAR  prec  LAI  GRSPs  NetPs  SlRes  CBaln  water  drain    ET   snow  stress"
   outpt.Print " DOY   oC    oC   um/m2/s  cm  m2/m2 -----------g/m2-----------  ---------- cm ----------- "
 End If
End If
  
If RealYear >= Val(IIout1.TabOutFrom) And RealYear <= Val(IIout1.TabOutTo) Then
  Print #3, Title$
  Print #3, "YEAR: ";
  Print #3, f7(RealYear);
  Print #3, "", "", "", "", FolNCon; "%N"
  Print #3, " ************************************************************************************************"
  Print #3, "      min T max T   PAR  prec  LAI  GRSPs  NetPs  SlRes  CBaln  water  drain    ET   snow  stress"
  Print #3, " DOY   oC    oC   um/m2/s  cm  m2/m2 -----------g/m2-----------  ---------- cm ----------- "
End If

End Sub

Sub IIYearOut()

' calculate NEP for PnET-II. Fromerly in AllocateYr routine.
NEP = TotPsn - FolGRespYr - WoodMRespYr - WoodGRespYr - SoilRespYr

'*********************** Print annual totals ****************************
If IIout1.Option3 = True Or IIout1.Option4 = True Then
 If PrintLevel = 1 And (nyears Mod PrintInt = 0 Or iday >= Val(ndays)) Then
   outpt.Print "*************************************************************************************************"
   If iday >= Val(ndays) Then
     outpt.Print: outpt.Print "Final Year", f7(RealYear): outpt.Print
   End If
   outpt.Print
   outpt.Print "    ------water balance (cm/yr) --------   gC/m2.yr -NPP g organic matter/m2.yr-"
   outpt.Print "    precip     trans      evap  drainage   net psn    foliage    wood  fine root"
   out$ = "   " + f6(TotPrec) + "   " + f6(totTrans) + "   " + f6(TotEvap) + "   " + f6(TotDrain) _
   + "   " + f6(Int(TotPsn)) + "   " + f6(Int(NPPFolYr)) + "   " + f6(Int(NPPWoodYr)) + "   " + f6(Int(NPPRootYr))
   outpt.Print out$
   outpt.Print
   outpt.Print " --------------------   Carbon Balances (g/m2.yr)   -----------------------"
   outpt.Print "GrsPsn netpsn  folgrs  folgrw  wdmrsp  wdgrsp  wdgrow  rtmrsp  rtgrsp  rtgrow  soilrs     NEP"
   out$ = f7(TotGrossPsn) + f7(TotPsn) + f7(FolGRespYr) + f7(FolProdCYr) + f7(WoodMRespYr) + f7(WoodGRespYr) + _
       f7(WoodProdCYr) + f7(RootMRespYr) + f7(RootGRespYr) + f7(RootProdCYr) + f7(SoilRespYr) + f7(NEP)
   outpt.Print out$
   dummy = InputBox("Hit 'OK' to continue,       'S' and 'OK' to stop.", "Output - Hold", , 6000, 7500)
   If dummy = "s" Or dummy = "S" Then
     outpt.Visible = False
     RealYear = Val(S.RunModelTo)
   End If
 End If
End If
If Left(PnET.ProjType, 1) = "S" Or Left(PnET.ProjType, 1) = "s" Then
If RealYear >= Val(IIout1.TabOutFrom) And RealYear <= Val(IIout1.TabOutTo) Then
  Print #3, "*************************************************************************************************"
  Print #3,
  Print #3, "    ------water balance (cm/yr) --------   gC/m2.yr -NPP g organic matter/m2.yr-"
  Print #3, "    precip     trans      evap  drainage   net psn    foliage    wood  fine root"
  out$ = "   " + f6(TotPrec) + "   " + f6(totTrans) + "   " + f6(TotEvap) + "   " + f6(TotDrain) _
   + "   " + f6(Int(TotPsn)) + "   " + f6(Int(NPPFolYr)) + "   " + f6(Int(NPPWoodYr)) + "   " + f6(Int(NPPRootYr))
  Print #3, out$
  Print #3,
  Print #3, " --------------------   Carbon Balances (g/m2.yr)   -----------------------"
  Print #3, "grspsn netpsn  folgrs  folgrw  wdmrsp  wdgrsp  wdgrow  rtmrsp  rtgrsp  rtgrow  soilrs     NEP"
  out$ = f7(TotGrossPsn) + f7(TotPsn) + f7(FolGRespYr) + f7(FolProdCYr) + f7(WoodMRespYr) + f7(WoodGRespYr) _
  + f7(WoodProdCYr) + f7(RootMRespYr) + f7(RootGRespYr) + f7(RootProdCYr) + f7(SoilRespYr) + f7(NEP)
  Print #3, out$
End If
End If
If IIout1.Option2 = True And RealYear >= Val(IIout2.GraphFrom) And RealYear <= Val(IIout2.GraphTo) Then
  outn = outn + 1
  outdatx(outn) = RealYear
  If IIout2.Check1(0) = 1 Then outdaty(1, outn) = NPPFolYr
  If IIout2.Check1(1) = 1 Then outdaty(2, outn) = NPPWoodYr
  If IIout2.Check1(2) = 1 Then outdaty(3, outn) = TotDrain
  If IIout2.Check1(3) = 1 Then outdaty(4, outn) = NEP
  If IIout2.Check1(4) = 1 Then outdaty(5, outn) = valid1
  If IIout2.Check1(5) = 1 Then outdaty(6, outn) = valid2
  If IIout2.Check1(6) = 1 Then outdaty(7, outn) = valid3
  If IIout2.Check1(7) = 1 Then outdaty(8, outn) = valid4
End If
 If Left(PnET.ProjType, 1) = "S" Or Left(PnET.ProjType, 1) = "s" Then
  Print #4, f5(RealYear); f8(Int(TotGrossPsn)); f6(Int(TotPsn)); _
            f6(Int(NPPFolYr)); f7(Int(NPPWoodYr)); f7(Int(NPPRootYr)); _
            f6(TotPrec); f6(TotO3Dose); f6(totTrans + TotEvap); _
            f6(TotDrain); f5(Int(NEP))
End If
End Sub

Sub PnETII()
    RootC = WoodC / 3 'initalization added Nov 2001
    iday = 0
    outpt3.Visible = True
    nyears = 0
    Call IIInit
    
nextday:
  'For iday = 1 To ndays
    iday = iday + 1
    Call ReadDay
    If iday = 1 Then Call IINewYear
    If NewYear = 1 And iday <> 1 Then
      Call AllocateYr
      Call IIYearOut
'   Try leaving this ou, since increments in IIYearOut 8-17-99
'     nyears = nyears + 1
'      If iday >= ndays Then GoTo endit   try removal 5-19
      If RealYear >= Val(S.RunModelTo) Then GoTo endit
      Call IINewYear
    End If
    
    Call Scenario
    Call AtmEnviron
    Call Phenology(1)
    Call Photosyn
    Call Waterbal
    Call SoilResp
    Call AllocateMo
    Call Phenology(2)
    Call IIDOYOut
    'If iday > Val(S.maxdays) And Val(S.maxdays) > 0 Then GoTo endit
    '               formerly iday = ndays and >= val(s.maxdays)
  'Next iday
  GoTo nextday
endit:
  Call IIFinalOut
  Close #1: Close #2: Close #3: Close #4: Close #5
  outpt.Visible = False: outpt3.Visible = False
End Sub

